<template>
  <button
    v-if="visible"
    class="va-backtop"
    role="button"
    aria-label="back to top"
    :style="computedStyle"
    @click="scrollToTop"
    @keydown.enter.stop="scrollToTop"
  >
    <slot>
      UP
    </slot>
  </button>
</template>

<script setup lang="ts">
import type { PropType } from "vue"

const props = defineProps({
  target: {
    type: [Object, String] as PropType<Element | string | undefined>,
    default: undefined,
  },
  visibilityHeight: { type: Number, default: 300 },
  speed: { type: Number, default: 50 },
  verticalOffset: { type: String, default: '1rem' },
  horizontalOffset: { type: String, default: '1rem' },
  color: { type: String, default: '' },
  horizontalPosition: {
    type: String as PropType<'right' | 'left'>,
    default: 'right',
    validator: (value: string) => ['right', 'left'].includes(value),
  },
  verticalPosition: {
    type: String as PropType<'bottom' | 'top'>,
    default: 'bottom',
    validator: (value: string) => ['bottom', 'top'].includes(value),
  },
})

const targetScrollValue = ref(0)

const computedStyle = computed(() => ({
  [props.verticalPosition]: props.verticalOffset,
  [props.horizontalPosition]: props.horizontalOffset,
}))

const scrollToTop = () => {
  window.scrollTo({
    top: 0,
    behavior: 'smooth',
  })
}

const visible = computed(() => targetScrollValue.value > props.visibilityHeight)
const handleScroll = () => targetScrollValue.value = window.scrollY
onMounted(() => window.addEventListener('scroll', handleScroll, true))
onBeforeUnmount(() => window?.removeEventListener('scroll', handleScroll))
</script>
